## vdeplug4 4.0.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13)
project(vdeplug4
    VERSION 4.0.0
    DESCRIPTION "Virtual Distributed Ethernet. Plug your VM directly to the cloud."
    HOMEPAGE_URL "https://github.com/rd235/vdeplug4"
    LANGUAGES C)

include(GNUInstallDirs)
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -pedantic")
include_directories(
		${PROJECT_SOURCE_DIR}/include
		${PROJECT_SOURCE_DIR}/srcvdeplug4
)

include(CheckIncludeFile)
set(LIBS_REQUIRED execs)

foreach(THISLIB IN LISTS LIBS_REQUIRED)
  find_library(LIB${THISLIB}_OK ${THISLIB})
  if(NOT LIB${THISLIB}_OK)
    message(FATAL_ERROR "library lib${THISLIB} not found")
  endif()
endforeach(THISLIB)

add_subdirectory(libvdeplug4)
add_subdirectory(srcvdeplug4)
add_subdirectory(libvdeplug4_static)
add_subdirectory(include)
add_subdirectory(doc)
add_subdirectory(man)

add_custom_target(uninstall
	"${CMAKE_COMMAND}" -P "${PROJECT_SOURCE_DIR}/Uninstall.cmake")

=== doc/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13)

install(FILES howto_create_a_vdeplug_plugin DESTINATION ${CMAKE_INSTALL_DOCDIR})

=== include/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13)
  
set_target_properties(vdeplug PROPERTIES PUBLIC_HEADER libvdeplug.h)
set_target_properties(vdeplug_mod PROPERTIES PUBLIC_HEADER libvdeplug_mod.h)

install(
        TARGETS vdeplug vdeplug_mod
        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
        PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
)

=== libvdeplug4/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13)
  
set(VDEPLUG_SOVERSION 2)
add_library(vdeplug SHARED libvdeplug.c libvdestream.c)
set_target_properties(vdeplug PROPERTIES VERSION ${PROJECT_VERSION}
    SOVERSION ${VDEPLUG_SOVERSION})
target_link_libraries(vdeplug -ldl)
target_link_libraries(vdeplug -export-dynamic)

add_library(vdeplug_mod SHARED parseparms.c vde_hashtable.c)
set_target_properties(vdeplug_mod PROPERTIES VERSION ${PROJECT_VERSION}
    SOVERSION ${VDEPLUG_SOVERSION})
target_link_libraries(vdeplug_mod -ldl)
target_link_libraries(vdeplug_mod -export-dynamic)

add_library(vdeplug_vde SHARED libvdeplug_vde.c)
target_link_libraries(vdeplug_vde vdeplug_mod)

add_library(vdeplug_ptp SHARED libvdeplug_ptp.c)
target_link_libraries(vdeplug_ptp vdeplug_mod)

add_library(vdeplug_tap SHARED libvdeplug_tap.c)
target_link_libraries(vdeplug_tap vdeplug_mod)

add_library(vdeplug_udp SHARED libvdeplug_udp.c)
target_link_libraries(vdeplug_udp vdeplug_mod)

add_library(vdeplug_vxlan SHARED libvdeplug_vxlan.c)
target_link_libraries(vdeplug_vxlan vdeplug_mod)

add_library(vdeplug_vxvde SHARED libvdeplug_vxvde.c)
target_link_libraries(vdeplug_vxvde vdeplug_mod)

add_library(vdeplug_cmd SHARED libvdeplug_cmd.c)
target_link_libraries(vdeplug_cmd vdeplug_mod -lexecs)

add_library(vdeplug_null SHARED libvdeplug_null.c)
target_link_libraries(vdeplug_null vdeplug_mod)

add_library(vdeplug_hub SHARED libvdeplug_hub.c libvdeplug_netnode.c)
target_link_libraries(vdeplug_hub vdeplug_mod)

add_library(vdeplug_switch SHARED libvdeplug_switch.c libvdeplug_netnode.c)
target_link_libraries(vdeplug_switch vdeplug_mod)

add_library(vdeplug_multi SHARED libvdeplug_multi.c libvdeplug_netnode.c)
target_link_libraries(vdeplug_multi vdeplug_mod)

add_library(vdeplug_bonding SHARED libvdeplug_bonding.c libvdeplug_netnode.c)
target_link_libraries(vdeplug_bonding vdeplug_mod)

add_library(vdeplug_seqpacket SHARED libvdeplug_seqpacket.c)
target_link_libraries(vdeplug_seqpacket vdeplug_mod)

install(
        TARGETS vdeplug_mod vdeplug
        LIBRARY
        DESTINATION ${CMAKE_INSTALL_LIBDIR}
		)

install(
        TARGETS vdeplug_vde vdeplug_ptp vdeplug_tap
                vdeplug_udp vdeplug_vxlan vdeplug_vxvde vdeplug_cmd
                vdeplug_null vdeplug_hub vdeplug_switch vdeplug_multi
                vdeplug_bonding vdeplug_seqpacket
        LIBRARY
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/vdeplug
		)

=== libvdeplug4_static/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13)
  
add_library(libvdeplug_a STATIC libvdeplug.c)
set_target_properties(libvdeplug_a PROPERTIES OUTPUT_NAME vdeplug)

install(
        TARGETS libvdeplug_a
        ARCHIVE
        DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

=== man/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.7)

set(RONN_ORGANIZATION "VirtualSquare")
set(RONN_ARGS --organization=${RONN_ORGANIZATION})
 
# #ronn pages

 file(GLOB VU_RONN_PAGES ${CMAKE_CURRENT_SOURCE_DIR}/*.[1-8].ronn)
set(VU_MAN_FILES)
foreach(VU_RONN_PATH IN LISTS VU_RONN_PAGES)
# VU_RONNPAGE: basename of VU_RONN_PATH
	get_filename_component(VU_RONNPAGE ${VU_RONN_PATH} NAME)
# VU_MANPAGE: VU_RONNPAGE without the suffix
	string(REGEX REPLACE "\.ronn$" "" VU_MANPAGE ${VU_RONNPAGE})
	list(APPEND VU_MAN_FILES ${VU_MANPAGE})
endforeach(VU_RONN_PATH)

add_custom_target(${PROJECT_NAME}_manpages ALL make RONN_ARGS="${RONN_ARGS}"  ${VU_MAN_FILES}
	WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})

### man pages
file(GLOB VU_MAN_PAGES ${CMAKE_CURRENT_SOURCE_DIR}/*.[1-8])
foreach(VU_MAN_PATH IN LISTS VU_MAN_PAGES)
	get_filename_component(VU_MANPAGE ${VU_MAN_PATH} NAME)
	string(REGEX REPLACE ".*\\." "" MAN_CHAPTER ${VU_MANPAGE})
	install(FILES ${VU_MAN_PATH} DESTINATION ${CMAKE_INSTALL_MANDIR}/man${MAN_CHAPTER})
endforeach(VU_MAN_PATH)

=== srcvdeplug4/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13)
  
add_executable(
        vde_plug vde_plug.c vde_plug_log.c vde_plug_iplog.c openclosepidfile.c
        selfsighandler.c
)
target_link_libraries(vde_plug vdeplug)

add_executable(dpipe dpipe.c openclosepidfile.c selfsighandler.c)

install(
        TARGETS vde_plug dpipe
        RUNTIME
        DESTINATION ${CMAKE_INSTALL_BINDIR}
)

=== debian/changelog ===
vdeplug4 (4.0.1-5.1build1) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 16:21:52 +1100

vdeplug4 (4.0.1-5.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1063043

 -- Steve Langasek <vorlon@debian.org>  Thu, 29 Feb 2024 08:54:03 +0000

vdeplug4 (4.0.1-5) unstable; urgency=medium

  * Delete useless explicit lib deps in d/control
  * Bump Standards-Version to 4.6.2, no changes needed.

 -- Renzo Davoli <renzo@cs.unibo.it>  Sat, 24 Jun 2023 11:50:36 +0200

vdeplug4 (4.0.1-4) unstable; urgency=medium

  [ Renzo Davoli ]
  * Fix reproducible-builds:: BuildId differences triggered by RPATH
  (Closes: #1003912)
  [ Andrea Capriotti]
  * Bump Standards-Version to 4.6.1, no changes needed.

 -- Andrea Capriotti <capriott@debian.org>  Fri, 12 Aug 2022 16:02:49 +0200

vdeplug4 (4.0.1-3) unstable; urgency=medium

  * Team upload.

  [ Renzo Davoli ]
  * Fix debian/watch file.

  [ Mattia Rizzolo ]
  * Bump Standards-Version to 4.6.0, no changes needed.
  * Mark libvdeplug-dev and libvdeplug2 as M-A:same.

 -- Mattia Rizzolo <mattia@debian.org>  Thu, 02 Dec 2021 11:24:44 +0100

vdeplug4 (4.0.1-2) unstable; urgency=medium

  * Team upload.

  [ Mattia Biondi ]
  * Update my email address in Uploaders.

  [ Mattia Rizzolo ]
  * Upload to unstable.

 -- Mattia Rizzolo <mattia@debian.org>  Wed, 21 Oct 2020 18:59:40 +0200

vdeplug4 (4.0.1-1) experimental; urgency=medium

  * New upstream release
  * d/control: Bump debhelper's compat level to 13
  * d/rules: Fix dh_auto_install syntax

 -- Andrea Capriotti <capriott@debian.org>  Tue, 13 Oct 2020 20:17:30 +0200

vdeplug4 (4.0.0-2) experimental; urgency=medium

  * Fix libvdeplug2 dependency on libexecs0

 -- Renzo Davoli <renzo@cs.unibo.it>  Sat, 10 Oct 2020 11:22:29 +0200

vdeplug4 (4.0.0-1) experimental; urgency=medium

  [ Mattia Biondi ]
  * Initial release

 -- Renzo Davoli <renzo@cs.unibo.it>  Thu, 30 Jan 2020 16:51:22 +0100

=== debian/control ===
Source: vdeplug4
Section: net
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian VirtualSquare Team <virtualsquare@cs.unibo.it>
Uploaders: Mattia Biondi <mattiabiondi1@gmail.com>, Renzo Davoli <renzo@cs.unibo.it>, Andrea Capriotti <capriott@debian.org>
Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13), cmake (>= 3.13), libexecs-dev
Standards-Version: 4.6.2
Rules-Requires-Root: no
Homepage: http://wiki.virtualsquare.org/
Vcs-Browser: https://salsa.debian.org/virtualsquare-team/vdeplug4
Vcs-Git: https://salsa.debian.org/virtualsquare-team/vdeplug4.git

Package: vdeplug
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libvdeplug2t64 (= ${binary:Version})
Breaks: vde2 (<< 2.3.2+r586-3)
Replaces: vde2 (<< 2.3.2+r586-3)
Description: Virtual Distributed Ethernet: A modular virtual plug to the VDE
 VDE provides a versatile support to create Ethernet compliant
 virtual networks. The vdeplug library, like an ethernet plug, can
 be used to connect virtual machines, namespaces, IoTh (Internet
 of Threads) processes or VDE utility commands to virtual networks.
 .
 This library uses plug-ins to support several VDE implementations
 and to be open to new developments in virtual networking.
 .
 Several plugins are included as standard extensions of the library, e.g.:
  - vde: connect to legacy vde_switch (provided by vde2) or
    to virtual networking sockets, see below
  - vxvde: this plug-in implements distributed virtual switches
    (implementation of a Local Area Cloud)
  - tap: connect to a tuntap interface
  - udp: udp tunnelling
  - ptp: point to point connection
  - vxlan: the plug becomes a vxlan's VTEP
  - cmd: stream the network flow to a command
 A plug can provide virtual networking sockets where other plug can
 be connected (using the vde plugin)
  - hub: the plug implements a hub
  - switch: the plug implements a switch
 .
 This package contains some utility tools for VDE including vde_plug.

Package: libvdeplug2t64
Provides: ${t64:Provides}
Replaces: libvdeplug2
Breaks: libvdeplug2 (<< ${source:Version})
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Virtual Distributed Ethernet - Plug library
 VDE provides a versatile support to create Ethernet compliant
 virtual networks. The vdeplug library, like an ethernet plug, can
 be used to connect virtual machines, namespaces, IoTh (Internet
 of Threads) processes or VDE utility commands to virtual networks.
 .
 This library uses plug-ins to support several VDE implementations
 and to be open to new developments in virtual networking.
 .
 Several plugins are included as standard extensions of the library, e.g.:
  - vde: connect to legacy vde_switch (provided by vde2) or
    to virtual networking sockets, see below
  - vxvde: this plug-in implements distributed virtual switches
    (implementation of a Local Area Cloud)
  - tap: connect to a tuntap interface
  - udp: udp tunnelling
  - ptp: point to point connection
  - vxlan: the plug becomes a vxlan's VTEP
  - cmd: stream the network flow to a command
 A plug can provide virtual networking sockets where other plug can
 be connected (using the vde plugin)
  - hub: the plug implements a hub
  - switch: the plug implements a switch
 .
 This package contains a modular library and a set of plugins supporting
 several VDE implementations

Package: libvdeplug-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, libvdeplug2t64 (= ${binary:Version})
Description: Virtual Distributed Ethernet - Plug development files
 VDE provides a versatile support to create Ethernet compliant
 virtual networks. The vdeplug library, like an ethernet plug, can
 be used to connect virtual machines, namespaces, IoTh (Internet
 of Threads) processes or VDE utility commands to virtual networks.
 .
 This library uses plug-ins to support several VDE implementations
 and to be open to new developments in virtual networking.
 .
 Several plugins are included as standard extensions of the library, e.g.:
  - vde: connect to legacy vde_switch (provided by vde2) or
    to virtual networking sockets, see below
  - vxvde: this plug-in implements distributed virtual switches
    (implementation of a Local Area Cloud)
  - tap: connect to a tuntap interface
  - udp: udp tunnelling
  - ptp: point to point connection
  - vxlan: the plug becomes a vxlan's VTEP
  - cmd: stream the network flow to a command
 A plug can provide virtual networking sockets where other plug can
 be connected (using the vde plugin)
  - hub: the plug implements a hub
  - switch: the plug implements a switch
 .
 This package contains the development files for libvdeplug.

=== debian/rules ===
#!/usr/bin/make -f

# output every command that modifies files on the build system.
#export DH_VERBOSE = 1

# see FEATURE AREAS in dpkg-buildflags(1)
#export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@

override_dh_auto_install:
	dh_auto_install --destdir=debian/tmp

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_BUILD_RPATH_USE_ORIGIN=ON
